//---------------------------------------------------------------------------
//
// Copyright (C) 2003 Don Powrie, DLP Design, All Rights Reserved.
// 
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this source code to use it without restriction, including without 
// limitation the rights to use, copy, modify, merge, publish, distribute, 
// sublicense, and/or sell copies of the Software, and to permit persons to 
// whom the source code is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included 
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
// IN NO EVENT SHALL DLP DESIGN BE LIABLE FOR ANY CLAIM, DAMAGES 
// OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
// OTHER DEALINGS IN THE SOFTWARE.
// 
//---------------------------------------------------------------------------

// PersCodeDlg.cpp : implementation file
#include "stdafx.h"
#include "PersCode.h"
#include "PersCodeDlg.h"
#include "ftd2xx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPersCodeDlg dialog

CPersCodeDlg::CPersCodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPersCodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPersCodeDlg)
	m_RetData = 0;
	m_ID = _T("");
	m_PBAD = _T("");
	m_TempPB = _T("");
	m_RR = _T("");
	m_PortSel = 2;
	m_PortData = _T("");
	m_Addr = 0;
	m_Data = 0;
	m_WriteResult = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPersCodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPersCodeDlg)
	DDX_Text(pDX, IDC_EDIT_RET_DATA, m_RetData);
	DDX_Text(pDX, IDC_EDIT_ID, m_ID);
	DDX_Text(pDX, IDC_EDIT_PBAD, m_PBAD);
	DDX_Text(pDX, IDC_EDIT_TEMP, m_TempPB);
	DDX_Text(pDX, IDC_EDIT_RESET_RESULT, m_RR);
	DDX_Radio(pDX, IDC_RADIO_PORT_SEL, m_PortSel);
	DDX_Text(pDX, IDC_EDIT_PORT_DATA, m_PortData);
	DDX_Text(pDX, IDC_EDIT_EE_ADDR, m_Addr);
	DDX_Text(pDX, IDC_EDIT_EE_DATA, m_Data);
	DDX_Text(pDX, IDC_EDIT_EEWRITE_RESULT, m_WriteResult);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPersCodeDlg, CDialog)
	//{{AFX_MSG_MAP(CPersCodeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_ID, OnButtonId)
	ON_BN_CLICKED(IDC_BUTTON_SETUP_PBAD, OnButtonSetupPLAD)
	ON_BN_CLICKED(IDC_BUTTON_READ_PBAD, OnButtonReadPLAD)
	ON_BN_CLICKED(IDC_BUTTON_SETUP_DIGITAL, OnButtonSetupDigital)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	ON_BN_CLICKED(IDC_BUTTON_PORT_WRITE, OnButtonPortWrite)
	ON_BN_CLICKED(IDC_BUTTON_READ_PORT, OnButtonReadPort)
	ON_BN_CLICKED(IDC_BUTTON_CONVERT, OnButtonConvert)
	ON_BN_CLICKED(IDC_BUTTON_TESTPL, OnButtonTestpl)
	ON_BN_CLICKED(IDC_BUTTON_F6_HIGH, OnButtonF6High)
	ON_BN_CLICKED(IDC_BUTTON_F6_LOW, OnButtonF6Low)
	ON_BN_CLICKED(IDC_BUTTON_READ_F4, OnButtonReadF4)
	ON_BN_CLICKED(IDC_BUTTON_EE_WRITE, OnButtonEeWrite)
	ON_BN_CLICKED(IDC_BUTTON_EE_READ, OnButtonEeRead)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPersCodeDlg message handlers


void CPersCodeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPersCodeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPersCodeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}





//****************************************************************************************
//****************************************************************************************
//****************************************************************************************
BOOL CPersCodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	LoadDLL();

	//attempt to open an attached FTDI device
	ULONG x=0;
	FT_STATUS status = Open((PVOID)x);
	if(status)//fail - no module
	{
		AfxMessageBox("Error: Could not open a device");
	}
	else//pass - module opened
	{
	}

	SetTimeouts(500, 500);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


//****************************************************************************************
int CPersCodeDlg::LoadDLL()//return 0 for success
{
	m_hmodule = LoadLibrary("Ftd2xx.dll");	
	if(m_hmodule == NULL)
	{
		AfxMessageBox("Error: Can't Load ftd2xx.dll driver software.");
		return 1;
	}

	m_pWrite = (PtrToWrite)GetProcAddress(m_hmodule, "FT_Write");
	if (m_pWrite == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Write");
		return 1;
	}

	m_pRead = (PtrToRead)GetProcAddress(m_hmodule, "FT_Read");
	if (m_pRead == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Read");
		return 1;
	}

	m_pOpen = (PtrToOpen)GetProcAddress(m_hmodule, "FT_Open");
	if (m_pOpen == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Open");
		return 1;
	}

	m_pOpenEx = (PtrToOpenEx)GetProcAddress(m_hmodule, "FT_OpenEx");
	if (m_pOpenEx == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_OpenEx");
		return 1;
	}

	m_pListDevices = (PtrToListDevices)GetProcAddress(m_hmodule, "FT_ListDevices");
	if(m_pListDevices == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_ListDevices");
		return 1;
	}

	m_pClose = (PtrToClose)GetProcAddress(m_hmodule, "FT_Close");
	if (m_pClose == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Close");
		return 1;
	}

	m_pResetDevice = (PtrToResetDevice)GetProcAddress(m_hmodule, "FT_ResetDevice");
	if (m_pResetDevice == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_ResetDevice");
		return 1;
	}

	m_pPurge = (PtrToPurge)GetProcAddress(m_hmodule, "FT_Purge");
	if (m_pPurge == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_Purge");
		return 1;
	}

	m_pSetTimeouts = (PtrToSetTimeouts)GetProcAddress(m_hmodule, "FT_SetTimeouts");
	if (m_pSetTimeouts == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_SetTimeouts");
		return 1;
	}

	m_pGetQueueStatus = (PtrToGetQueueStatus)GetProcAddress(m_hmodule, "FT_GetQueueStatus");
	if (m_pGetQueueStatus == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_GetQueueStatus");
		return 1;
	}

	m_pEE_Program = (PtrToEE_Program)GetProcAddress(m_hmodule, "FT_EE_Program");
	if (m_pEE_Program == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_EE_Program");
		return 1;
	}

	m_pEE_Read = (PtrToEE_Read)GetProcAddress(m_hmodule, "FT_EE_Read");
	if (m_pEE_Read == NULL)
	{
		AfxMessageBox("Error: Can't Find FT_EE_Read");
		return 1;
	}

	
	return 0;
}	




//****************************************************************************************
FT_STATUS CPersCodeDlg::EE_Read(PFT_PROGRAM_DATA lpData)
{
	if (!m_pEE_Read)
	{
		AfxMessageBox("FT_EE_Read is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pEE_Read)(m_ftHandle, lpData);
}	


//****************************************************************************************
FT_STATUS CPersCodeDlg::EE_Program(PFT_PROGRAM_DATA lpData)
{
	if (!m_pEE_Program)
	{
		AfxMessageBox("FT_EE_Program is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pEE_Program)(m_ftHandle, lpData);
}	



//****************************************************************************************
FT_STATUS CPersCodeDlg::Read(LPVOID lpvBuffer, DWORD dwBuffSize, LPDWORD lpdwBytesRead)
{
	if (!m_pRead)
	{
		AfxMessageBox("FT_Read is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pRead)(m_ftHandle, lpvBuffer, dwBuffSize, lpdwBytesRead);
}	

//****************************************************************************************
FT_STATUS CPersCodeDlg::Write(LPVOID lpvBuffer, DWORD dwBuffSize, LPDWORD lpdwBytes)
{
	if (!m_pWrite)
	{
		AfxMessageBox("FT_Write is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pWrite)(m_ftHandle, lpvBuffer, dwBuffSize, lpdwBytes);
}	


//****************************************************************************************
FT_STATUS CPersCodeDlg::Open(PVOID pvDevice)
{
	if (!m_pOpen)
	{
		AfxMessageBox("FT_Open is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pOpen)(pvDevice, &m_ftHandle );
}	

//****************************************************************************************
FT_STATUS CPersCodeDlg::OpenEx(PVOID pArg1, DWORD dwFlags)
{
	if (!m_pOpenEx)
	{
		AfxMessageBox("FT_OpenEx is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pOpenEx)(pArg1, dwFlags, &m_ftHandle);
}	


//****************************************************************************************
FT_STATUS CPersCodeDlg::ListDevices(PVOID pArg1, PVOID pArg2, DWORD dwFlags)
{
	if (!m_pListDevices)
	{
		AfxMessageBox("FT_ListDevices is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pListDevices)(pArg1, pArg2, dwFlags);
}	


//****************************************************************************************
FT_STATUS CPersCodeDlg::Close()
{
	if (!m_pClose)
	{
		AfxMessageBox("FT_Close is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pClose)(m_ftHandle);
}	

//****************************************************************************************
FT_STATUS CPersCodeDlg::ResetDevice()
{
	if (!m_pResetDevice)
	{
		AfxMessageBox("FT_ResetDevice is not valid!"); 
		return FT_INVALID_HANDLE;
	}
	
	return (*m_pResetDevice)(m_ftHandle);
}	

//****************************************************************************************
FT_STATUS CPersCodeDlg::Purge(DWORD dwMask)
{
	if (!m_pPurge)
	{
		AfxMessageBox("FT_Purge is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pPurge)(m_ftHandle, dwMask);
}	

//****************************************************************************************
FT_STATUS CPersCodeDlg::SetTimeouts(DWORD dwReadTimeout, DWORD dwWriteTimeout)
{
	if (!m_pSetTimeouts)
	{
		AfxMessageBox("FT_SetTimeouts is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pSetTimeouts)(m_ftHandle, dwReadTimeout, dwWriteTimeout);
}	

//****************************************************************************************
FT_STATUS CPersCodeDlg::GetQueueStatus(LPDWORD lpdwAmountInRxQueue)
{
	if (!m_pGetQueueStatus)
	{
		AfxMessageBox("FT_GetQueueStatus is not valid!"); 
		return FT_INVALID_HANDLE;
	}

	return (*m_pGetQueueStatus)(m_ftHandle, lpdwAmountInRxQueue);
}	





//generic for any selected pin
//*********************************************************************
void CPersCodeDlg::make_hi(int port_pin)
{
	unsigned char tx[100];

	//****** send command to make output
	int pos=0;
	tx[pos++] = 0xA6;//Line Output command
	tx[pos++] = port_pin;
	tx[pos++] = 1;//make line high
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1256)");
		return;
	}
}


//generic for any selected pin
//*********************************************************************
void CPersCodeDlg::make_low(int port_pin)
{
	unsigned char tx[100];

	//****** send command to make output
	int pos=0;
	tx[pos++] = 0xA6;//Line Output command
	tx[pos++] = port_pin;
	tx[pos++] = 0;//make line low
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1259)");
		return;
	}
}


//generic for any selected pin
//*********************************************************************
int CPersCodeDlg::read_pin(int pin_to_read, int *data)
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	Purge(FT_PURGE_RX || FT_PURGE_TX);

	//****** send command to read input
	int pos=0;
	tx[pos++] = 0xA5;//Line Input command
	tx[pos++] = pin_to_read;//select Port Pin 
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(125)");
		return 1;
	}

	//read the data back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return 2;
	}
	
	*data = rx[0];

	return 0;//no error
}












//************************************************************************
void CPersCodeDlg::OnButtonId() 
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	UpdateData(TRUE);
	m_ID = "";
	UpdateData(FALSE);
	UpdateWindow();

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(600, 600);

	//****** send command to read input pin
	int pos=0;
	tx[pos++] = 0xA7;//Return Board ID command
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1284)");
		return;
	}

	//read the data back in
	FT_STATUS status = Read(rx, 5, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}
	

	UpdateData(TRUE);
	m_ID = (LPCTSTR)rx;
	m_ID = m_ID.Left(5);
	UpdateData(FALSE);
	UpdateWindow();
}





/*
////////////////////////////////////////////////////////////////// ADC
// ADC Functions: SETUP_ADC(), SETUP_ADC_PORTS() (aka SETUP_PORT_A),
//                SET_ADC_CHANNEL(), READ_ADC()
// Constants used in SETUP_ADC_PORTS() are:
#define NO_ANALOGS             0x0F         // None
#define ALL_ANALOG             0x00         // A0 A1 A2 A3 A5 F0 F1 F2 F3 F4 F5 F6 H4 H5 H6 H7
#define ANALOG_AN0_TO_AN13     0x01         // A0 A1 A2 A3 A5 F0 F1 F2 F3 F4 F5 F6 H4 H5
#define ANALOG_AN0_TO_AN12     0x02         // A0 A1 A2 A3 A5 F0 F1 F2 F3 F4 F5 F6 H4
#define ANALOG_AN0_TO_AN11     0x03         // A0 A1 A2 A3 A5 F0 F1 F2 F3 F4 F5 F6
#define ANALOG_AN0_TO_AN10     0x04         // A0 A1 A2 A3 A5 F0 F1 F2 F3 F4 F5
#define ANALOG_AN0_TO_AN9      0x05         // A0 A1 A2 A3 A5 F0 F1 F2 F3 F4
#define ANALOG_AN0_TO_AN8      0x06         // A0 A1 A2 A3 A5 F0 F1 F2 F3
#define ANALOG_AN0_TO_AN7      0x07         // A0 A1 A2 A3 A5 F0 F1 F2
#define ANALOG_AN0_TO_AN6      0x08         // A0 A1 A2 A3 A5 F0 F1
#define ANALOG_AN0_TO_AN5      0x09         // A0 A1 A2 A3 A5 F0
#define ANALOG_AN0_TO_AN4      0x0A         // A0 A1 A2 A3 A5
#define ANALOG_AN0_TO_AN3      0x0B         // A0 A1 A2 A3
#define ANALOG_AN0_TO_AN2      0x0C         // A0 A1 A2
#define ANALOG_AN0_TO_AN1      0x0D         // A0 A1
#define ANALOG_AN0             0x0E         // A0

// OR any of the following with the above:
#define VSS_VDD               0x00
#define VREF_VREF             0x30
#define VREF_VDD              0x20
#define VSS_VREF              0x10

// Constants used for SETUP_ADC() are:
#define ADC_OFF                0 //0
#define ADC_CLOCK_DIV_2    0x100 //1
#define ADC_CLOCK_DIV_4    0x104 //2
#define ADC_CLOCK_DIV_8    0x101 //3
#define ADC_CLOCK_DIV_16   0x105 //4
#define ADC_CLOCK_DIV_32   0x102 //5
#define ADC_CLOCK_DIV_64   0x106 //6
#define ADC_CLOCK_INTERNAL 0x107 //7
*/
//************************************************************************
void CPersCodeDlg::OnButtonSetupPLAD() 
{
	unsigned char tx[100];

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(500, 500);

	//****** send command to configure A/D
	int pos=0;
	tx[pos++] = 0xA8;//command for Setup A/D command
	tx[pos++] = 0x0E;//analog channel 0 active, VREF+ at VDD and VREF- at Ground
	tx[pos++] = 0x7;//Fosc/64 for 20MHz operation
	tx[pos++] = PIN_A0;//set A0 TRIS tristate register in the 18F8720 to input
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1286)");
		return;
	}
}



//************************************************************************
void CPersCodeDlg::OnButtonSetupDigital() 
{
	unsigned char tx[100];

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(500, 500);

	//****** send command to configure A/D
	int pos=0;
	tx[pos++] = 0xA8;//Setup A/D command
	tx[pos++] = 0x0F;//all digital
	tx[pos++] = 0x0;//A/D Off
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1286)");
		return;
	}
}


//************************************************************************
void CPersCodeDlg::OnButtonReadPLAD() 
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;


	UpdateData(TRUE);
	m_PBAD = "";
	UpdateData(FALSE);
	UpdateWindow();

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(500, 500);

	//****** send command to read A/D
	int pos=0;
	tx[pos++] = 0xA9;//Read A/D command
	tx[pos++] = 0;//A/D channel to be read
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1287)");
		return;
	}

	//read the data back in
	FT_STATUS status = Read(rx, 2, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}

	int LSB = (int)rx[0];
	int MSB = (int)rx[1];

	unsigned int ivolts = ( LSB | (MSB<<8) );
	double dvolts = (double)ivolts * 5.0 / 1024.0;

	UpdateData(TRUE);
	m_PBAD.Format("%1.3f", dvolts);
	UpdateData(FALSE);
	UpdateWindow();
}



//**********************************************************************************
void CPersCodeDlg::OnButtonConvert() //start conversion on sensor attached to PIN_B0
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	UpdateData(TRUE);
	m_RR = "";
	UpdateData(FALSE);
	UpdateWindow();

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(100, 100);

	//****** send command to read input pin
	int pos=0;
	tx[pos++] = 0xAC;//Reset Temp sensor and start convert command
	tx[pos++] = PIN_G0;
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1284)");
		return;
	}

	//read the result back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}
	
	unsigned char ret = rx[0];

	UpdateData(TRUE);
	m_RR.Format("%d", ret); 
	UpdateData(FALSE);
	UpdateWindow();
}





//************************************************************************
void CPersCodeDlg::OnButtonRead() //0xAD
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	UpdateData(TRUE);
	m_TempPB = "";
	UpdateData(FALSE);
	UpdateWindow();

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(300, 300);

	//****** send command to read input pin
	int pos=0;
	tx[pos++] = 0xAD;//Reset Temp sensor and request the 9 data bytes
	tx[pos++] = PIN_G0;
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1284)");
		return;
	}

	Sleep(5);
	//read the result back in
	FT_STATUS status = Read(rx, 9, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}

	if(ret_bytes != 9)
	{
		CString str;
		str.Format("Error: Only %d bytes returned. 5", ret_bytes);
		AfxMessageBox(str);
		return;
	}


	int isnegative=0;
	unsigned int temp = rx[0] | (rx[1] << 8);

	if( (temp & 0x8000) == 0x8000 )//if MSBit is set then negative temperature
	{
		temp &= 0x07ff;
		isnegative=1;
		temp = 0x800 - temp;
	}
	temp &= 0x07ff;
	float degc = (float)((float)temp/16.0);
	if(isnegative) degc *= -1;

	UpdateData(TRUE);
	m_TempPB.Format("%.1f F", degc*9.0/5.0 + 32.0);
	UpdateData(FALSE);
	UpdateWindow();
}




//************************************************************************
void CPersCodeDlg::OnButtonPortWrite() 
{
	unsigned char tx[100];

	UpdateData(TRUE);

	if(m_PortSel == -1)
	{
		AfxMessageBox("No port selected for writing.");
		return;
	}

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(100, 100);

	int WriteCommand;
	if(m_PortSel == 0) WriteCommand = 0x56;//Port A
	if(m_PortSel == 1) WriteCommand = 0x5A;//Port C
	if(m_PortSel == 2) WriteCommand = 0x5C;//Port D
	if(m_PortSel == 3) WriteCommand = 0x5E;//Port E
	if(m_PortSel == 4) WriteCommand = 0x66;//Port F
	if(m_PortSel == 5) WriteCommand = 0x6A;//Port H

	int data = atoi((LPCTSTR)m_PortData);
	
	//****** send command to write port wide data
	int pos=0;
	tx[pos++] = WriteCommand;
	tx[pos++] = data;
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1319)");
		return;
	}
}



//************************************************************************
void CPersCodeDlg::OnButtonReadPort() 
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	UpdateData(TRUE);
	m_PortData = "";
	UpdateData(FALSE);
	UpdateWindow();

	if(m_PortSel == -1)
	{
		AfxMessageBox("No port selected for reading.");
		return;
	}

	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(100, 100);


	int ReadCommand;
	if(m_PortSel == 0) ReadCommand = 0x55;//Port A
	if(m_PortSel == 1) ReadCommand = 0x59;//Port C
	if(m_PortSel == 2) ReadCommand = 0x5B;//Port D
	if(m_PortSel == 3) ReadCommand = 0x5D;//Port E
	if(m_PortSel == 4) ReadCommand = 0x65;//Port F
	if(m_PortSel == 5) ReadCommand = 0x69;//Port H

	//****** send command to read port wide data
	int pos=0;
	tx[pos++] = ReadCommand;
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1321)");
		return;
	}

	//read the result back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}

	if(ret_bytes == 0)
	{
		UpdateData(TRUE);
		m_PortData.Format("timeout");
	}
	else
	{
		unsigned char ret = rx[0];
		UpdateData(TRUE);
		m_PortData.Format("0x%2.2X   %d", ret, ret);
	}

	UpdateData(FALSE);
	UpdateWindow();

}




//*******************************************************************************
void CPersCodeDlg::OnButtonTestpl() 
{
	int data, result;
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;


	//start convert
	OnButtonConvert();

	SetTimeouts(100, 100);

	//test databus
	for(int x=0; x<230; x+=6)
	{
		int pos=0;
		tx[pos++] = 0xAF;//Loopback command
		tx[pos++] = x;
		int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
		if(res==0)//error
		{
			AfxMessageBox("DLP module not responding to commands.(1259)");
			return;
		}

		//read the data back in
		FT_STATUS status = Read(rx, 1, &ret_bytes);
		if(status != FT_OK)
		{
			AfxMessageBox("USB Error: DLP module not responding to commands.");
			return;
		}
	
		if(x != rx[0])
		{
			AfxMessageBox("Loopback failed.");
			return;
		}
	}





	make_hi(PIN_F6);
	result = read_pin(PIN_F4, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins F6, F4");
		return;
	}
	

	make_low(PIN_F6);
	result = read_pin(PIN_F4, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins F6, F4");
		return;
	}



	make_hi(PIN_F2);
	result = read_pin(PIN_H6, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins F2, H6");
		return;
	}
	

	make_low(PIN_F2);
	result = read_pin(PIN_H6, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins F2, H6");
		return;
	}



	make_hi(PIN_H4);
	result = read_pin(PIN_F0, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins H4, F0");
		return;
	}
	

	make_low(PIN_H4);
	result = read_pin(PIN_F0, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins H4, F0");
		return;
	}



	make_hi(PIN_A2);
	result = read_pin(PIN_A4, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins A4, A2");
		return;
	}
	

	make_low(PIN_A2);
	result = read_pin(PIN_A4, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins A4, A2");
		return;
	}



	make_hi(PIN_H0);
	result = read_pin(PIN_H2, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins H0, H2");
		return;
	}
	

	make_low(PIN_H0);
	result = read_pin(PIN_H2, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins H0, H2");
		return;
	}




	make_hi(PIN_F7);
	result = read_pin(PIN_F5, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins F7, F5");
		return;
	}
	

	make_low(PIN_F7);
	result = read_pin(PIN_F5, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins F7, F5");
		return;
	}




	make_hi(PIN_F3);
	result = read_pin(PIN_H7, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins F3, H7");
		return;
	}
	

	make_low(PIN_F3);
	result = read_pin(PIN_H7, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins F3, H7");
		return;
	}



	make_hi(PIN_H5);
	result = read_pin(PIN_F1, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins H5, F1");
		return;
	}
	

	make_low(PIN_H5);
	result = read_pin(PIN_F1, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins H5, F1");
		return;
	}



	make_hi(PIN_A5);
	result = read_pin(PIN_A3, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins A5, A3");
		return;
	}
	

	make_low(PIN_A5);
	result = read_pin(PIN_A3, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins A5, A3");
		return;
	}



	make_hi(PIN_A0);
	result = read_pin(PIN_A1, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins A0, A1");
		return;
	}
	

	make_low(PIN_A0);
	result = read_pin(PIN_A1, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins A0, A1");
		return;
	}




	make_hi(PIN_H1);
	result = read_pin(PIN_H3, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins H1, H3");
		return;
	}
	

	make_low(PIN_H1);
	result = read_pin(PIN_H3, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins H1, H3");
		return;
	}




	make_hi(PIN_G0);
	result = read_pin(PIN_G3, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins G0, G3");
		return;
	}
	

	make_low(PIN_G0);
	result = read_pin(PIN_G3, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins G0, G3");
		return;
	}

	read_pin(PIN_G0, &data);//clear for reading the temp sensor



	make_hi(PIN_B0);
	result = read_pin(PIN_B1, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins B0, B1");
		return;
	}
	

	make_low(PIN_B0);
	result = read_pin(PIN_B1, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins B0, B1");
		return;
	}



	make_hi(PIN_B3);
	result = read_pin(PIN_J0, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins B3, J0");
		return;
	}
	

	make_low(PIN_B3);
	result = read_pin(PIN_J0, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins B3, J0");
		return;
	}




	make_hi(PIN_J1);
	result = read_pin(PIN_J2, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins J1, J2");
		return;
	}
	

	make_low(PIN_J1);
	result = read_pin(PIN_J2, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins J1, J2");
		return;
	}




	make_hi(PIN_J3);
	result = read_pin(PIN_J4, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins J3, J4");
		return;
	}
	

	make_low(PIN_J3);
	result = read_pin(PIN_J4, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins J3, J4");
		return;
	}





	make_hi(PIN_J6);
	result = read_pin(PIN_J7, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==0)
	{
		AfxMessageBox("error using port pins J6, J7");
		return;
	}
	

	make_low(PIN_J6);
	result = read_pin(PIN_J7, &data);
	if(result)
	{
		AfxMessageBox("USB error reading port pins ");
		return;
	}
	if(data==1)
	{
		AfxMessageBox("error using port pins J6, J7");
		return;
	}




	
	//****** send command to write port wide data on Port E
	int pos=0;
	tx[pos++] = 0x5E;//command
	tx[pos++] = 0x5A;//data
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1319)");
		return;
	}


	//****** send command to read port wide data on Prt C
	pos=0;
	tx[pos++] = 0x59;
	res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1321)");
		return;
	}

	//read the result back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}

	if(ret_bytes == 0)
	{
		UpdateData(TRUE);
		AfxMessageBox("Timeout");
	}
	else
	{
		unsigned char ret = rx[0];
		if(ret != 0x5A)
		{
			CString str;
			str.Format("Data error during port read/write test. 2 Expected 0x5A, Read 0x%02.2X", ret);
			AfxMessageBox(str);
//			return;
		}
	}


	//****** send command to write port wide data on Port E
	pos=0;
	tx[pos++] = 0x5E;//command
	tx[pos++] = 0xA5;//data
	res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1319)");
		return;
	}


	//****** send command to read port wide data on Prt C
	pos=0;
	tx[pos++] = 0x59;
	res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1321)");
		return;
	}

	//read the result back in
	status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}

	if(ret_bytes == 0)
	{
		UpdateData(TRUE);
		AfxMessageBox("Timeout");
	}
	else
	{
		unsigned char ret = rx[0];
		if(ret != 0xA5)
			AfxMessageBox("Data error during port read/write test. 1");

	}


	OnButtonRead();

	//****** send command to read temp sensor 
	pos=0;
	tx[pos++] = 0xAD;//Reset Temp sensor and request the 9 data bytes
	tx[pos++] = PIN_G0;
	res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(1284)");
		return;
	}

	//read the result back in
	status = Read(rx, 9, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}

	if(ret_bytes != 9)
	{
		CString str;
		str.Format("Error: Only %d bytes returned. 6", ret_bytes);
		AfxMessageBox(str);
		return;
	}


	int isnegative=0;
	unsigned int temp = rx[0] | (rx[1] << 8);

	if( (temp & 0x8000) == 0x8000 )//if MSBit is set then negative temperature
	{
		temp &= 0x07ff;
		isnegative=1;
		temp = 0x800 - temp;
	}
	temp &= 0x07ff;
	float degc = (float)((float)temp/16.0);
	if(isnegative) degc *= -1;

	if((degc < 20) || (degc > 30))
	{
		AfxMessageBox("Temperature test failed");
		return;
	}

	if(WriteEeDefault() > 0)
	{
		AfxMessageBox("EEPROM init failed.");
		return;
	}

	CString str;
	str.Format("All Tests Passed. (%.1f)", degc);
	AfxMessageBox(str);
}




//***********************************************************************
void CPersCodeDlg::OnButtonF6High() 
{
	unsigned char tx[100];

	//****** send command to make output
	int pos=0;
	tx[pos++] = 0xA6;//Line Output command
	tx[pos++] = PIN_F6;//select Port Pin E0
	tx[pos++] = 1;//make line high
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(125)");
		return;
	}
}


//***********************************************************************
void CPersCodeDlg::OnButtonF6Low() 
{
	unsigned char tx[100];

	//****** send command to make output
	int pos=0;
	tx[pos++] = 0xA6;//Line Output command
	tx[pos++] = PIN_F6;//select Port Pin E0
	tx[pos++] = 0;//make line high
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(126)");
		return;
	}
}



//***********************************************************************
void CPersCodeDlg::OnButtonReadF4() 
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	Purge(FT_PURGE_RX || FT_PURGE_TX);

	//****** send command to read input pin
	int pos=0;
	tx[pos++] = 0xA5;//Line Input command
	tx[pos++] = PIN_F4;//select Port Pin A0
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(127)");
		return;
	}

	//read the data back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}
	unsigned char ret = rx[0];

	UpdateData(TRUE);
	m_RetData = ret;
	UpdateData(FALSE);
	UpdateWindow();
}



//***********************************************************************
void CPersCodeDlg::OnButtonEeWrite() 
{
	unsigned char tx[100];

	UpdateData(TRUE);
	m_WriteResult = " ";
	UpdateData(FALSE);
	UpdateWindow();

	//****** send command to make output
	int pos=0;
	tx[pos++] = 0xAB;//EEPROM Write command
	tx[pos++] = (unsigned char)(m_Addr & 0xff00) >> 8;//address MSB
	tx[pos++] = (unsigned char)(m_Addr & 0x00ff);//address LSB
	tx[pos++] = (unsigned char)m_Data;//data from screen
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(125)");
		return;
	}

	UpdateData(TRUE);
	m_WriteResult = "Write complete.";
	UpdateData(FALSE);
	UpdateWindow();
}




//***********************************************************************
void CPersCodeDlg::OnButtonEeRead() 
{
	unsigned char tx[100], rx[100], data;
	DWORD ret_bytes;

	UpdateData(TRUE);

	//****** send command to make output
	int pos=0;
	tx[pos++] = 0xAA;//EEPROM Read command
	tx[pos++] = (unsigned char)(m_Addr & 0xff00) >> 8;//address MSB
	tx[pos++] = (unsigned char)(m_Addr & 0x00ff);//address LSB
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(125)");
		return;
	}

	//read the data back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}
	
	UpdateData(TRUE);
	data = rx[0];
	m_Data = data;
	UpdateData(FALSE);
	UpdateWindow();
}

/*
void CPersCodeDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	AfxMessageBox("DLP module not responding to commands.");
	
	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}
*/

void CPersCodeDlg::OnButton2() 
{
	unsigned char tx[100], rx[100];
	DWORD ret_bytes;

	Purge(FT_PURGE_RX || FT_PURGE_TX);

	//****** send command to read input pin
	int pos=0;
	tx[pos++] = 0xAF;//loopback
	tx[pos++] = 0xAA;//select Port Pin A0
	int res = SendCommandString(tx, pos);//return: 0=fail, 1=pass
	if(res==0)//error
	{
		AfxMessageBox("DLP module not responding to commands.(127)");
		return;
	}

	//read the data back in
	FT_STATUS status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		AfxMessageBox("DLP module not responding to commands.");
		return;
	}
	unsigned char ret = rx[0];

	UpdateData(TRUE);
	m_ID.Format("%X", ret); 
	UpdateData(FALSE);
	UpdateWindow();


}




//******************************************************************
int CPersCodeDlg::SendCommandString(unsigned char *com_str, int num_bytes)//return 0=fail, 1=pass
{
	unsigned char checksum;
	unsigned char rx[50], tx[50];
	DWORD ret_bytes;
	
	//load Xmit buffer, add checksum, send and receive ACK (0x55)
	Purge(FT_PURGE_RX || FT_PURGE_TX);
	SetTimeouts(700, 700);


	tx[0] = num_bytes;	

	int pos=1;
	for(int x=0; x<num_bytes; x++)
		tx[pos++] = com_str[x];

	//calculate checksum and append to command string
	checksum=0;
	for(x=0; x<pos; x++)
		checksum ^= tx[x];
	tx[pos++] = checksum;

	FT_STATUS status = Write(tx, pos, &ret_bytes);
	if(status != FT_OK)
	{
		//AfxMessageBox("Driver error writing to DLP module. ");
		return 0;//error
	}

	Sleep(10);

	//just read in the one character we are expecting
	status = Read(rx, 1, &ret_bytes);
	if(status != FT_OK)
	{
		//AfxMessageBox("DLP module not responding to commands.");
		return 0;//error
	}

	if(ret_bytes < 1)
	{
		AfxMessageBox("Timeout occurred");
		return 0;//error
	}

	unsigned char ret = rx[0];
	if(ret == 0x55)
		return 1;//pass
	else
	{
		//AfxMessageBox("DLP module not responding to commands.");
		return 0;//error
	}
}


//******************************************************************
int CPersCodeDlg::WriteEeDefault() 
{
	FT_STATUS status;
	FT_PROGRAM_DATA ftData = 
	{
		0x0,			// Header - must be 0x00000000 
		0xffffffff,		// Header - must be 0xffffffff
		2,				// Header - FT_PROGRAM_DATA version
						//          0 = original
	                    //          1 = FT2232C extens
						//			2 = FT232R

		0x0403,			//VID
		0x6001,			//PID
		"DLP Design",	//Manufacturer string
		"DP",			//Manufacturer ID string
		"DLP-245PL-G",	//description string
		"",				//serial number
		490,			//max current
		1,				//PNP
		0,				//Self Powered
		1,				//Remote wakeup
		//
		// Rev4 extensions
		//
		FALSE,			//Rev4
		FALSE,			//in endpoint type
		FALSE,			//out endpoint type
		FALSE,			//pulldown
		TRUE,			//serial number
		FALSE,			//USB Version select
		0,				//USB version
		//
		// FT2232C extensions
		//
		FALSE,			// non-zero if Rev5 chip, zero otherwise
		FALSE,			// TRUE if in endpoint is isochronous
		FALSE,			// TRUE if in endpoint is isochronous
		FALSE,			// TRUE if out endpoint is isochronous
		FALSE,			// TRUE if out endpoint is isochronous
		FALSE,			// TRUE if pull down enabled
		TRUE,			// TRUE if serial number to be used
		FALSE,			// TRUE if chip uses USBVersion
		0,				// BCD (0x0200 => USB2)
		
		FALSE,			// TRUE if A interface is high current
		FALSE,			// TRUE if B interface is high current
		
		FALSE,			// TRUE if A interface is 245 FIFO
		FALSE,			// TRUE if A interface is 245 FIFO CPU target
		FALSE,			// TRUE if A interface is Fast serial
		TRUE,			// TRUE if A interface is to use VCP drivers

		FALSE,			// TRUE if B interface is 245 FIFO
		FALSE,			// TRUE if B interface is 245 FIFO CPU target
		FALSE,			// TRUE if B interface is Fast serial
		TRUE,			// TRUE if B interface is to use VCP drivers
		//
		// FT232R extensions
		//
		FALSE,			// Use External Oscillator
		FALSE,			// High Drive I/Os
		64,				// Endpoint size

		FALSE,			// non-zero if pull down enabled
		TRUE,			// non-zero if serial number to be used

		FALSE,			// non-zero if invert TXD
		FALSE,			// non-zero if invert RXD
		FALSE,			// non-zero if invert RTS
		FALSE,			// non-zero if invert CTS
		FALSE,			// non-zero if invert DTR
		FALSE,			// non-zero if invert DSR
		FALSE,			// non-zero if invert DCD
		FALSE,			// non-zero if invert RI

		0x2,			// Cbus Mux control
		0x9,			// Cbus Mux control
		0xf,			// Cbus Mux control
		0xf,			// Cbus Mux control
		0x1,			// Cbus Mux control

		TRUE			// TRUE if using DLL drivers
} ;

	status = EE_Program(&ftData);
	if (status == FT_OK) 
	{
		return 0;
	}
	else 
	{
		return 1;
	}
}

/*


//******************************************************************
void CPersCodeDlg::OnButtonReadEeData() 
{
	FT_STATUS status;
	FT_PROGRAM_DATA ftData;//declare the structure

	//create the actual storage space
	char ManufacturerBuf[32];
	char ManufacturerIdBuf[16];
	char DescriptionBuf[64];
	char SerialNumberBuf[16];
	CString str;
	
	//transfer the storage space pointers to the structure
	ftData.Manufacturer = ManufacturerBuf;
	ftData.ManufacturerId = ManufacturerIdBuf;
	ftData.Description = DescriptionBuf;
	ftData.SerialNumber = SerialNumberBuf;

	status = EE_Read(&ftData);
	if (status == FT_OK)//FT_EE_Read OK, data is available in ftData
	{
		CString str; 
		str.Format("Manufacturer string: %s  \n\nManufacturer ID string: %s  \n\nDescription string: %s  \n\nSerial number: %s \n\n", 
						ftData.Manufacturer,	
						ftData.ManufacturerId,
						ftData.Description,
						ftData.SerialNumber	);
		AfxMessageBox(str);
	}
	else 
	{
		AfxMessageBox("EE_Read FAILED!");
	}

}

*/