//---------------------------------------------------------------------------
//
// Copyright (C) 2002 Don Powrie, DLP Design, All Rights Reserved.
// 
// Permission is hereby granted, free of charge, to any person obtaining a 
// copy of this source code to use it without restriction, including without 
// limitation the rights to use, copy, modify, merge, publish, distribute, 
// sublicense, and/or sell copies of the Software, and to permit persons to 
// whom the source code is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included 
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY,  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
// IN NO EVENT SHALL DLP DESIGN BE LIABLE FOR ANY CLAIM, DAMAGES 
// OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
// OTHER DEALINGS IN THE SOFTWARE.
// 
//---------------------------------------------------------------------------

// PersCodeDlg.h : header file
#include "ftd2xx.h"


#if !defined(AFX_PERSCODEDLG_H__E0109191_04BD_4B5B_93E4_C7648F1E5395__INCLUDED_)
#define AFX_PERSCODEDLG_H__E0109191_04BD_4B5B_93E4_C7648F1E5395__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CPersCodeDlg dialog

//port pin definitions
#define PIN_A0  44
#define PIN_A1  45
#define PIN_A2  46
#define PIN_A3  47
#define PIN_A4  48
#define PIN_A5  49

#define PIN_B0  52
#define PIN_B1  53
#define PIN_B2  54
#define PIN_B3  55
#define PIN_B4  56
#define PIN_B5  57
#define PIN_B6  58
#define PIN_B7  59

#define PIN_C0  60
#define PIN_C1  61
#define PIN_C2  62
#define PIN_C3  63
#define PIN_C4  64
#define PIN_C5  65
#define PIN_C6  66
#define PIN_C7  67

#define PIN_D0  68
#define PIN_D1  69
#define PIN_D2  70
#define PIN_D3  71
#define PIN_D4  72
#define PIN_D5  73
#define PIN_D6  74
#define PIN_D7  75

#define PIN_E0  76
#define PIN_E1  77
#define PIN_E2  78
#define PIN_E3  79
#define PIN_E4  80
#define PIN_E5  81
#define PIN_E6  82
#define PIN_E7  83

#define PIN_F0  84
#define PIN_F1  85
#define PIN_F2  86
#define PIN_F3  87
#define PIN_F4  88
#define PIN_F5  89
#define PIN_F6  90
#define PIN_F7  91

#define PIN_G0  92
#define PIN_G1  93
#define PIN_G2  94
#define PIN_G3  95
#define PIN_G4  96

#define PIN_H0  100
#define PIN_H1  101
#define PIN_H2  102
#define PIN_H3  103
#define PIN_H4  104
#define PIN_H5  105
#define PIN_H6  106
#define PIN_H7  107

#define PIN_J0  108
#define PIN_J1  109
#define PIN_J2  110
#define PIN_J3  111
#define PIN_J4  112
#define PIN_J5  113
#define PIN_J6  114
#define PIN_J7  115



class CPersCodeDlg : public CDialog
{
// Construction
public:
	CPersCodeDlg(CWnd* pParent = NULL);	// standard constructor
	int CPersCodeDlg::SendCommandString(unsigned char *com_str, int num_bytes);
	int CPersCodeDlg::LoadDLL();
	void CPersCodeDlg::make_hi(int port_pin);
	int CPersCodeDlg::read_pin(int pin_to_read, int *data);
    void CPersCodeDlg::make_low(int port_pin);
	int CPersCodeDlg::WriteEeDefault(); 
 



// Dialog Data
	//{{AFX_DATA(CPersCodeDlg)
	enum { IDD = IDD_PERSCODE_DIALOG };
	int		m_RetData;
	CString	m_ID;
	CString	m_PBAD;
	CString	m_TempPB;
	CString	m_RR;
	int		m_PortSel;
	CString	m_PortData;
	UINT	m_Addr;
	BYTE	m_Data;
	CString	m_WriteResult;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPersCodeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	HMODULE m_hmodule;

	FT_HANDLE m_ftHandle;

//	typedef FT_STATUS (WINAPI *PtrToOpen)(PVOID, FT_HANDLE *); 
//	PtrToOpen m_pOpen; 
//	FT_STATUS Open();
	
	typedef FT_STATUS (WINAPI *PtrToOpen)(PVOID, FT_HANDLE *); 
	PtrToOpen m_pOpen; 
	FT_STATUS Open(PVOID);

	typedef FT_STATUS (WINAPI *PtrToOpenEx)(PVOID, DWORD, FT_HANDLE *); 
	PtrToOpenEx m_pOpenEx; 
	FT_STATUS OpenEx(PVOID, DWORD);

	typedef FT_STATUS (WINAPI *PtrToClose)(FT_HANDLE);
	PtrToClose m_pClose;
	FT_STATUS Close();

	typedef FT_STATUS (WINAPI *PtrToRead)(FT_HANDLE, LPVOID, DWORD, LPDWORD);
	PtrToRead m_pRead;
	FT_STATUS Read(LPVOID, DWORD, LPDWORD);

	typedef FT_STATUS (WINAPI *PtrToWrite)(FT_HANDLE, LPVOID, DWORD, LPDWORD);
	PtrToWrite m_pWrite;
	FT_STATUS Write(LPVOID, DWORD, LPDWORD);

	typedef FT_STATUS (WINAPI *PtrToResetDevice)(FT_HANDLE);
	PtrToResetDevice m_pResetDevice;
	FT_STATUS ResetDevice();

	typedef FT_STATUS (WINAPI *PtrToListDevices)(PVOID, PVOID, DWORD);
	PtrToListDevices m_pListDevices; 
	FT_STATUS ListDevices(PVOID, PVOID, DWORD);

	typedef FT_STATUS (WINAPI *PtrToPurge)(FT_HANDLE, ULONG);
	PtrToPurge m_pPurge;
	FT_STATUS Purge(DWORD);
	
	typedef FT_STATUS (WINAPI *PtrToSetTimeouts)(FT_HANDLE, ULONG, ULONG);
	PtrToSetTimeouts m_pSetTimeouts;
	FT_STATUS SetTimeouts(DWORD, DWORD);

	typedef FT_STATUS (WINAPI *PtrToGetQueueStatus)(FT_HANDLE, LPDWORD);
	PtrToGetQueueStatus m_pGetQueueStatus;
	FT_STATUS GetQueueStatus(LPDWORD);

	typedef FT_STATUS (WINAPI *PtrToEE_Read)(FT_HANDLE, PFT_PROGRAM_DATA);
	PtrToEE_Read m_pEE_Read;
	FT_STATUS EE_Read(PFT_PROGRAM_DATA);

	typedef FT_STATUS (WINAPI *PtrToEE_Program)(FT_HANDLE, PFT_PROGRAM_DATA);
	PtrToEE_Program m_pEE_Program;
	FT_STATUS EE_Program(PFT_PROGRAM_DATA);



	// Generated message map functions
	//{{AFX_MSG(CPersCodeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonId();
	afx_msg void OnButtonSetupPLAD();
	afx_msg void OnButtonReadPLAD();
	afx_msg void OnButtonSetupDigital();
	afx_msg void OnButtonRead();
	afx_msg void OnButtonPortWrite();
	afx_msg void OnButtonReadPort();
	afx_msg void OnButtonConvert();
	afx_msg void OnButtonTestpl();
	afx_msg void OnButtonF6High();
	afx_msg void OnButtonF6Low();
	afx_msg void OnButtonReadF4();
	afx_msg void OnButtonEeWrite();
	afx_msg void OnButtonEeRead();
	afx_msg void OnButton2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PERSCODEDLG_H__E0109191_04BD_4B5B_93E4_C7648F1E5395__INCLUDED_)
